from Ft.Server.Console.Widgets import *

class TUserInit(TForm):
    def __init__(self, owner):
        TForm.__init__(self, owner,
                       caption='Create Super Users',
                       borderIcons=[biSystemMenu, biMinimize],
                       borderStyle=bsDialog,
                       clientHeight=215,
                       clientWidth=273,
                       color=clBtnFace,
                       position=poScreenCenter)

        self.onShow = self.onUserInitShow
        self.label1 = TLabel(self, top=8, left=8, caption='Super users:')

        self.superUsers = TListBox(self, top=28, left=8, width=148, height=136)

        self.createUser = TButton(self, top=30, left=165, width=100,
                                  caption='Create User',
                                  onClick=self.onCreateUserClick)
        self.editUser = TButton(self, top=65, left=165, width=100,
                                caption='Edit User',
                                onClick=self.onEditUserClick)
        self.deleteUser = TButton(self, top=100, left=165, width=100,
                                  caption='Delete User',
                                  onClick=self.onDeleteUserClick)
        # Added by default
        #self.addManagers = TButton(self, top=135, left=165, width=100, caption='Add Managers')

        self.okBtn = TButton(self, top=185, left=107, width=75,
                             default=1,
                             caption='OK',
                             modalResult=mrOk)
        self.cancelBtn = TButton(self, top=185, left=190, width=75,
                                 caption='Cancel',
                                 modalResult=mrCancel)
        return

    def onUserInitShow(self, sender):
        self.superUsers.items.clear()
        return

    def onCreateUserClick(self, sender):
        ModifyUser.userName.text = ''
        ModifyUser.password.text = ''
        ModifyUser.caption = self.createUser.caption
        if ModifyUser.showModal() == mrOk:
            index = self.superUsers.items.add(ModifyUser.userName.text)
            password = sha.new(ModifyUser.password.text).hexdigest()
            self.superUsers.items.objects[index] = password
        print 'create mr',ModifyUser.modalResult
        return

    def onEditUserClick(self, sender):
        index = self.superUsers.selected
        if index == -1:
            return
        ModifyUser.userName.text = self.superUsers.items.strings[index]
        ModifyUser.password.text = ''
        ModifyUser.caption = self.editUser.caption
        if ModifyUser.showModal() == mrOk:
            self.superUsers.items.strings[index] = ModifyUser.userName.text
            password = sha.new(ModifyUser.password.text).hexdigest()
            self.superUsers.items.objects[index] = password
        return

    def onDeleteUserClick(self, sender):
        index = self.superUsers.selected
        if index == -1:
            return
        userName = self.superUsers.items.strings[index]
        if AreYouSure('Delete User %s' % userName):
            self.superUsers.items.delete(index)
        return



class TModifyUser(TForm):
    def __init__(self, owner):
        TForm.__init__(self, owner,
                       borderIcons=[biSystemMenu, biMinimize],
                       borderStyle=bsDialog,
                       clientHeight=102,
                       clientWidth=254,
                       color=clBtnFace,
                       position=poScreenCenter)
        
        self.label1 = TLabel(self, top=10, left=8, caption='&Username:')
        self.label2 = TLabel(self, top=38, left=8, caption='&Password:')

        self.userName = TEdit(self, top=8, left=85)
        self.password = TEdit(self, top=36, left=85, passwordChar='*')

        self.okBtn = TButton(self, left=34, top=64, caption='OK',
                             default=1,
                             modalResult=mrOk)
        self.cancelBtn = TButton(self, left=145, top=64, caption='Cancel',
                                 modalResult=mrCancel)

