########################################################################
#
# File Name:            DocumentDefinitionProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import omniORB, cStringIO
import FtServerResources
from Ft.Server.Protocols.CORBA import MessageSource
import XmlDocumentProxy
import DocDefProxyHelper

#Overidden class
oldBase = omniORB.objrefMapping[FtServerResources.DocumentDefinitionIf._NP_RepositoryId]
class DocumentDefinitionProxyIf(oldBase,XmlDocumentProxy.XmlDocumentProxyIf):
    base = oldBase

    def generateStatements(self,uri,dom):
        if hasattr(dom,'nodeType'):
            st = cStringIO.StringIO()
            ext.Print(dom,stream=st)
            dom = st.getvalue()
        return self.base.generateStatements(self,uri,dom)

    def setNsMap(self,nss):
        nss = DocDefProxyHelper.NsMapToCorba(nss)
        return self.base.setNsMap(self,nss)

    def setCreationParams(self,cp):
        cp = DocDefProxyHelper.CreationParamsToCorba(cp)
        return self.base.setCreationParams(self,cp)

    def setRdfMaps(self,maps):
        maps = DocDefProxyHelper.RdfMapsToCorba(maps)
        return self.base.setRdfMaps(self,maps)


for name,value in XmlDocumentProxy.XmlDocumentProxyIf.__dict__.items():
    if name in ['__doc__','base','__module__']:
        continue
    setattr(DocumentDefinitionProxyIf,name,value)

omniORB.registerObjref(FtServerResources.DocumentDefinitionIf._NP_RepositoryId, DocumentDefinitionProxyIf)












