########################################################################
#
# File Name:            FactoryProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import omniORB
import FtServerFactory
from Ft.Server.Protocols.CORBA import MessageSource

#Overidden class
oldBase = omniORB.objrefMapping[FtServerFactory.FtServerFactoryIf._NP_RepositoryId]
class FactoryProxyIf(oldBase):
    base = oldBase

    def getRepository(self,userName,password,txTimeout=1000):
        return self.base.getRepository(self,userName,password,txTimeout)

    def getRepositoryAsAnonymous(self,txTimeout=1000):
        return self.base.getRepositoryAsAnonymous(self,txTimeout)

omniORB.registerObjref(FtServerFactory.FtServerFactoryIf._NP_RepositoryId,
                       FactoryProxyIf)












