########################################################################
#
# File Name:            RdfModelProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import omniORB
import FtServerResources
from Ft.Server.Protocols.CORBA import MessageSource

#Overidden class
oldBase = omniORB.objrefMapping[FtServerResources.RdfModelIf._NP_RepositoryId]
class RdfModelProxyIf(oldBase):
    base = oldBase

    allowedFlags = ['subjectFlags',
                    'predicateFlags',
                    'objectFlags',
                    'domainFlags',
                    'statementUriFlags']

    def removePattern(self, subject, predicate, object,
                      statementUri=None, domain=None, **flags):


        if subject is None:
            subject = ''
        if predicate is None:
            predicate = ''
        if object is None:
            object = ''
        if statementUri is None:
            statementUri = ''
        if domain is None:
            domain = ''
        return self.base.removePattern(self,
                                       subject,
                                       predicate,
                                       object,
                                       statementUri,
                                       domain,
                                       flags.get('subjectFlags',0),
                                       flags.get('predicateFlags',0),
                                       flags.get('objectFlags',0),
                                       flags.get('domainFlags',0),
                                       flags.get('statementUriFlags',0)
                                       )


    def complete(self, subject, predicate, object,
                 statementUri=None, domain=None, **flags):


        if subject is None:
            subject = ''
        if predicate is None:
            predicate = ''
        if object is None:
            object = ''
        if statementUri is None:
            statementUri = ''
        if domain is None:
            domain = ''
        return self.base.complete(self,
                                  subject,
                                  predicate,
                                  object,
                                  statementUri,
                                  domain,
                                  flags.get('subjectFlags',0),
                                  flags.get('predicateFlags',0),
                                  flags.get('objectFlags',0),
                                  flags.get('domainFlags',0),
                                  flags.get('statementUriFlags',0)
                                  )




omniORB.registerObjref(FtServerResources.RdfModelIf._NP_RepositoryId, RdfModelProxyIf)












