#ifndef __DOM__DOCUMENT__
#define __DOM__DOCUMENT__

#ifdef __cplusplus
extern "C" {
#endif

#include "Python.h"
#include "node.h"
#include "element.h"
#include "text.h"
#include "processinginstruction.h"
#include "comment.h"
#include "attr.h"
#include "documentfragment.h"

  extern PyObject *g_documentNodeType;
  extern PyObject *g_documentNodeName;


  typedef struct {
    PyDom_NODE
    PyObject *documentElement;
    PyObject *childNodes;
    PyObject *refUri;
    PyObject *docType;
    PyObject *internedUnicode;
  } PyDocumentObject;


  PyDocumentObject *Document_NEW(unsigned long *docIx, PyObject *refUri);

  PyElementObject *Document_CreateElementNS(PyDocumentObject *self,
					    PyObject *namespaceURI,
					    PyObject *prefix,
					    PyObject *localName,
					    unsigned long *docIx);


  PyAttrObject *Document_CreateAttributeNS(PyDocumentObject *self,
					   PyObject *namespaceURI,
					   PyObject *localName,
					   PyObject *prefix,
                                           PyObject *value,
					   unsigned long *docIx);

  PyTextObject *Document_CreateTextNode(PyDocumentObject *ownerDoc,
					PyObject *data,
					unsigned long *docIdx);

  PyDocumentFragmentObject *Document_CreateDocumentFragment(PyDocumentObject *ownerDoc,
							    unsigned long *docIdx);



  PyProcessingInstructionObject *Document_CreateProcessingInstruction(PyDocumentObject *self,
								    PyObject *target,
								    PyObject *data,
								    unsigned long *docIx);
  PyCommentObject *Document_CreateComment(PyDocumentObject *self,
                                          PyObject *data,
                                          unsigned long *docIx);


  PyObject *PyNode_importNode(PyObject *self,PyObject *args);


  int document_test_ref_counts(PyObject *tester,PyDocumentObject *doc,int base);

#define PyDocument_Check(op) ((op)->ob_type == &PyDomletteDocument_Type)
  extern DL_EXPORT(PyTypeObject) PyDomletteDocument_Type;



#ifdef __cplusplus
}
#endif


#endif
