#ifndef __DOM__UTIL__
#define __DOM__UTIL__

#ifdef __cplusplus
extern "C" {
#endif

#include "Python.h"

  /* nodeName manipulation */
void SplitQName(PyObject *qualifiedName, PyObject **prefix, PyObject **localName);
  
  /* testing */
void AddInternCtr(PyObject *obj, PyObject *dict);
int TestRefCount(PyObject *tester, PyObject *obj, int expected, const char *name);


/* See http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/67112 */
#if defined(DEBUG_PARSER)
#define Py_DEBUG
extern void _Py_CountReferences(FILE*);
#define CURIOUS(x) { fprintf(stderr, __FILE__ ":%d ", __LINE__); x; }
#else
#define CURIOUS(x)
#endif
#define NEWLINE()        CURIOUS(fprintf(stderr, "\n"))
#define DESCRIBE(x)     CURIOUS(fprintf(stderr, "  " #x "=%d\n", x))
#define DESCRIBE_HEX(x) CURIOUS(fprintf(stderr, "  " #x "=%08x\n", x))
#define COUNTREFS()     CURIOUS(_Py_CountReferences(stderr))


#ifdef __cplusplus
}
#endif

#endif
